{-# LANGUAGE MultiParamTypeClasses,
             FunctionalDependencies,
             FlexibleContexts
  #-}

module Control.Monad.MonadErrorP (      
       MonadErrorP (..),
       ThrowPerm (..),
       CatchPerm (..),
       TCPerm (..)
) where

import Control.Monad.Error
import EffectCapabilities

-- the lattice of Throw/Catch pemrmissions

data ThrowPerm = ThrowPerm
data CatchPerm = CatchPerm
data TCPerm    = TCPerm 

instance Implies TCPerm ThrowPerm
instance Implies TCPerm CatchPerm


class (Monad m, Error e) => MonadErrorP c e m | c m -> e where
    throwErrorp :: (Implies ac ThrowPerm, Capability c ac) => c ac -> e -> m a
    catchErrorp :: (Implies ac CatchPerm, Capability c ac) => c ac -> m a -> (e -> m a) -> m a
