{-# LANGUAGE MultiParamTypeClasses,
             FunctionalDependencies,
             FlexibleContexts,
             TypeOperators
  #-}

module Control.Monad.MonadStateP (MonadStateP (..), ReadPerm (..), WritePerm (..), RWPerm (..)) where

import EffectCapabilities
import Data.List

-- the lattice of Read/Write permissions

data WritePerm = WritePerm
data ReadPerm  = ReadPerm
data RWPerm    = RWPerm

instance Implies RWPerm ReadPerm
instance Implies RWPerm WritePerm

class Monad m => MonadStateP k s m | m -> s where
  getp :: (Capability k a, Implies a ReadPerm) => k a -> m s
  putp :: (Capability k a, Implies a WritePerm) => k a -> s -> m ()