{-# LANGUAGE TypeOperators,
             MultiParamTypeClasses,
             FunctionalDependencies,
             ScopedTypeVariables,
             FlexibleInstances,
             UndecidableInstances,
             ConstraintKinds,
             FlexibleContexts
  #-}

module MonadErrorPV (
       MonadErrorPV (..),
       ThrowPerm (..),
       CatchPerm (..),
       TCPerm (..)
) where

import Control.Monad.Error
import Control.Monad.ErrorTP
import Control.Monad.MonadErrorP
import Control.Monad.Mask
import Control.Monad.Views
import EffectCapabilities

class (MonadErrorP c e n, TWith (c ()) n m) 
      => MonadErrorPV c n m e | c -> n e where

      throwError :: (Capability c perm, Implies perm ThrowPerm)
                    => c perm -> e -> m a
      throwError c = checkCapability c `seq`
                     throwErrorPV c (structure (getTag c) :: n :><: m)

      catchError :: (Capability c perm, Implies perm CatchPerm)
                    => c perm -> m a -> (e -> m a) -> m a
      catchError c = checkCapability c `seq`
                     catchErrorPV c (structure (getTag c) :: n :><: m)

instance (MonadErrorP c e n, TWith (c ()) n m) => MonadErrorPV c n m e

throwErrorPV :: (Monad m, MonadErrorP c e n, View (~>), Capability c perm, Implies perm ThrowPerm)
                => c perm -> n ~> m -> e -> m a
throwErrorPV c v = from v . (throwErrorp c)

catchErrorPV :: (Monad m, MonadErrorP c e n, Capability c perm, Implies perm CatchPerm)
                => c perm -> n :><: m -> m a -> (e -> m a) -> m a
catchErrorPV c v ma hnd = from v $ (catchErrorp c (to v ma)
                                   (\ e -> (to v (hnd e))))


{-

catchErrorPV c v ma hnd = from v $ (catchErrorp c (to v ma)
                                   (\ e -> (to v (hnd e))))´
-}