{-# LANGUAGE FlexibleContexts,
             FlexibleInstances,
             MultiParamTypeClasses,
             TypeOperators,
             ScopedTypeVariables,
             FunctionalDependencies,
             UndecidableInstances
  #-}


module MonadStatePV (
       MonadStatePV (..),
       ReadPerm (..),
       WritePerm (..),
       RWPerm (..)
) where

import Control.Monad.State
import Control.Monad.Mask
import Control.Monad.Views
import Control.Monad.MonadStateP
import EffectCapabilities
import Control.Monad.State.StateTP
import Data.List

class (Monad m, MonadStateP c s n, TWith (c ()) n m)
      => MonadStatePV c n m s | c -> n s where
      get :: (Implies perm ReadPerm, Capability c perm) => c perm -> m s
      get c = getpv c (structure (getTag c) :: n :><: m)

      put :: (Implies perm WritePerm, Capability c perm) => c perm -> s -> m ()
      put c = putpv c (structure (getTag c) :: n :><: m)

instance (Monad m, MonadStateP capability s n,TWith (capability ()) n m)
         => MonadStatePV capability n m s

getpv k v = from v $ (getp k)
putpv k v = from v . (putp k)
