{-# LANGUAGE MultiParamTypeClasses
  #-}

module ProtectedIO.Permissions where

import EffectCapabilities

-- FileSystem permissions
data FileSystemPerm = FileSystemPerm
data StandardHandlesPerm = StandardHandlesPerm
data FileAccessPerm = FileAccessPerm
data TempFilesPerm = TempFilesPerm
data FileInputPerm = FileInputPerm
data FileOutputPerm = FileOutputPerm
data HandleOperationsPerm = HandleOperationsPerm
data HandleQueryOpsPerm = HandleQueryOpsPerm
data HandleChangeOpsPerm = HandleChangeOpsPerm

-- FileSystem permission lattice
instance Implies FileSystemPerm StandardHandlesPerm
instance Implies FileSystemPerm FileAccessPerm
instance Implies FileSystemPerm FileInputPerm
instance Implies FileSystemPerm FileOutputPerm
instance Implies FileSystemPerm HandleOperationsPerm
instance Implies FileAccessPerm TempFilesPerm
instance Implies HandleOperationsPerm HandleQueryOpsPerm
instance Implies HandleOperationsPerm HandleChangeOpsPerm


-- HandleIO permissions
data HandleIOPerm = HandleIOPerm
data BinaryIOPerm = BinaryIOPerm
data IOInputPerm  = IOInputPerm
data IOOutputPerm = IOOutputPerm
data TextIOPerm = TextIOPerm
data TextInputPerm = TextInputPerm
data TextOutputPerm = TextOutputPerm

-- HandleIO permission lattice
instance Implies HandleIOPerm BinaryIOPerm
instance Implies HandleIOPerm TextIOPerm
instance Implies BinaryIOPerm IOInputPerm
instance Implies BinaryIOPerm IOOutputPerm
instance Implies TextIOPerm TextInputPerm
instance Implies TextIOPerm TextOutputPerm

-- Encoding Permissions
data EncodingPerm = EncodingPerm
data ConstantsPerm = ConstantsPerm
data EncodingQueryOpsPerm = EncodingQueryOpsPerm
data EncodingQueryChangeOpsPerm = EncodingQueryChangeOpsPerm

-- Encoding permission lattice
instance Implies EncodingPerm ConstantsPerm
instance Implies EncodingPerm EncodingQueryOpsPerm
instance Implies EncodingPerm EncodingQueryChangeOpsPerm